 /* --------------------------------------------------------------------
    A. Veneziani - Classe che implementa una coda

                   Scritto in C++ Builder 6
    -------------------------------------------------------------------- */               

#include "conio.h"
#include <iostream>

using namespace std;

const DIM_CODA = 5;    // dimensione massima di coda

class Coda {

     // attributi della classe
     // vettore degli elementi e suo livello di riempimento (pos)
     int vett_coda[DIM_CODA];
     int pos;

     // scorrimento di tutti gli elementi della coda in avanti
     // a causa della uscita (con rimozione) di un elemento di testa
     //
     // puo' essere definito come private in quanto e' un operazione
     // che serve solo ad alcuni metodi dell'oggetto (in particolare pop())
     // dell'oggetto e non a chi usa le sue funzionalita'
     void scorri_elementi_avanti()
     {
         int i;

         for (i = 1; i < pos; i++)
             vett_coda[i - 1] = vett_coda[i];
     }

     public:

     // costrutttore della classe Coda
     // inizializza il valore dell'indicatore di riempimento
     // della coda pos a 0
     Coda() {
        pos = 0;
     }

     // metodo per estrarre un elemento dalla coda
     int pop()
     {
         int el_testa;

         el_testa = vett_coda[0];
         scorri_elementi_avanti();
         pos--;
         return(el_testa);
     }

     // inserisce un elemento in coda
     // (controllando se essa e' piena)
     void push(int n)
     {
        if (! e_piena())
        {
            vett_coda[pos] = n;
            pos++;
        }
        else
        {
            cout << "Inserimento elemento " << n << endl;        
            cout << "Coda piena. Operazione non possibile." << endl;
        }
     }

     // da' il numero di elementi attualmente in coda
     int lunghezza()
     {
         return(pos - 1);
     }

     // rende un valora booleano che indica se la coda e' piena o no
     bool e_piena()
     {
         if (pos == DIM_CODA)
            return(true);
         else
            return(false);
     }

     // rende un valora booleano che indica se la coda e' vuota o no
     bool e_vuota()
     {
        if (pos == 0)
           return(true);
        else
           return(false);
     }

     // stampa dei contenuti della coda
     void stampa_coda()
     {
        int i;

        if (! e_vuota())
        {
            for (i = 0; i < pos; i++)
                cout << vett_coda[i] << " ";
        }
        else
           cout << "<nessun elemento in coda>";       

        cout << endl;   
     }        

};

// programma main (di test)
void main()
{
    Coda Cd;

    // ciclo di push nella coda fino al suo riempimento totale
    Cd.push(3);
    Cd.push(10);
    Cd.push(8);
    Cd.push(3);
    Cd.push(1);
    Cd.push(4);      // questa operazione sulla coda rende
                     // un messaggio di errore perche' la coda e' piena
    // mostra la coda                 
    Cd.stampa_coda();

    // prima del pop() controlla la coerenza dell' operazione
    // (solo se la coda non  vuota essa  possibile, allora
    // effettua l'operazione ed usa il valore letto)
    if (! Cd.e_vuota())
        cout << "Estratto: " << Cd.pop() << endl;
    else
        cout << "Coda vuota, estrazione non possibile." << endl;

    if (! Cd.e_vuota())
        cout << "Estratto: " << Cd.pop() << endl;
    else
        cout << "Coda vuota, estrazione non possibile." << endl;

    if (! Cd.e_vuota())
        cout << "Estratto: " << Cd.pop() << endl;
    else
        cout << "Coda vuota, estrazione non possibile." << endl;

    if (! Cd.e_vuota())
        cout << "Estratto: " << Cd.pop() << endl;
    else
        cout << "Coda vuota, estrazione non possibile." << endl;

   if (! Cd.e_vuota())
        cout << "Estratto: " << Cd.pop() << endl;
    else
        cout << "Coda vuota, estrazione non possibile." << endl;

   if (! Cd.e_vuota())
        cout << "Estratto: " << Cd.pop() << endl;
    else
        cout << "Coda vuota, estrazione non possibile." << endl;

    // mostra nuovamente la coda
    // (essendo essa vuota si e' deciso di far apparire
    // un messaggio convenzionale)
    Cd.stampa_coda();

    getch();

}
